VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Huffman"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Declare Function HuffmanEncodeStr Lib "Huffman.dll" Alias "HuffmanEncode" ( _
  ByVal InText As String, _
  ByVal nLen As Long, _
  ByVal OutText As String _
) As Long

Private Declare Function HuffmanDecodeStr Lib "Huffman.dll" Alias "HuffmanDecode" ( _
  ByVal InText As String, _
  ByVal nLen As Long, _
  ByVal OutText As String _
) As Long

Private Declare Function GetEncodeLenStr Lib "Huffman.dll" Alias "GetEncodeLen" ( _
  ByVal InText As String, _
  ByVal nLen As Long _
) As Long

Private Declare Function GetDecodeLenStr Lib "Huffman.dll" Alias "GetDecodeLen" ( _
  ByVal InText As String, _
  ByVal nLen As Long _
) As Long
'----------------------------------------------------

Private Declare Function HuffmanEncode Lib "Huffman.dll" ( _
  ByRef InText As Byte, _
  ByVal nLen As Long, _
  ByRef OutText As Byte _
) As Long

Private Declare Function HuffmanDecode Lib "Huffman.dll" ( _
  ByRef InText As Byte, _
  ByVal nLen As Long, _
  ByRef OutText As Byte _
) As Long

Private Declare Function GetEncodeLen Lib "Huffman.dll" ( _
  ByRef InText As Byte, _
  ByVal nLen As Long _
) As Long

Private Declare Function GetDecodeLen Lib "Huffman.dll" ( _
  ByRef InText As Byte, _
  ByVal nLen As Long _
) As Long
'----------------------------------------------------

Public Function EncodeString(Text As String) As String
    Dim OutLen      As Long
    
    OutLen = GetEncodeLenStr(Text, Len(Text))
    EncodeString = Space$(OutLen)
    Call HuffmanEncodeStr(Text, Len(Text), EncodeString)
End Function

Public Function DecodeString(Text As String) As String
    Dim OutLen      As Long
    
    OutLen = GetDecodeLenStr(Text, Len(Text))
    DecodeString = Space$(OutLen)
    Call HuffmanDecodeStr(Text, Len(Text), DecodeString)
End Function

Public Sub EncodeBytes(Source() As Byte, Destination() As Byte)
    Dim OutLen      As Long
    
    OutLen = GetEncodeLen(Source(0), UBound(Source) - 1)
    ReDim Destination(OutLen - 1)
    Call HuffmanEncode(Source(0), UBound(Source) - 1, Destination(0))
End Sub

Public Sub DecodeBytes(Source() As Byte, Destination() As Byte)
    Dim OutLen      As Long
    
    OutLen = GetDecodeLen(Source(0), UBound(Source) - 1)
    ReDim Destination(OutLen - 1)
    Call HuffmanDecode(Source(0), UBound(Source) - 1, Destination(0))
End Sub
